;********************************************************************
;*			File name: uChipSimu.inc								*
;*			Date created: 26th June 2009							*
;*			Author : Tan Ghee Siak									*
;********************************************************************

					Init_Controls	PROTO	:DWORD
					CheckBoxRoutine	PROTO	:DWORD,:DWORD,:DWORD,:DWORD
					LabelRoutine	PROTO	:DWORD,:DWORD,:DWORD,:DWORD
					SetTextRoutine	PROTO	:DWORD, :DWORD, :DWORD
			
MAX_INSTRUCTIONS	equ		256					;

IDC_CHECKBOX1		equ		500					; instruction 1 checkbox
IDC_CHECKBOX2		equ		501					;
IDC_CHECKBOX3		equ		502					;
IDC_CHECKBOX4		equ		503					;
IDC_CHECKBOX5		equ		504					;
IDC_CHECKBOX6		equ		505					;
IDC_CHECKBOX7		equ		506					;
IDC_CHECKBOX8		equ		507					;
IDC_CHECKBOX9		equ		508					;
IDC_CHECKBOX10		equ		509					;
IDC_CHECKBOX11		equ		510					;
IDC_CHECKBOX12		equ		511					;
IDC_CHECKBOX13		equ		512					;
IDC_CHECKBOX14		equ		513					;
IDC_CHECKBOX15		equ		514					;
IDC_CHECKBOX16		equ		515					;
IDC_CHECKBOX17		equ		516					;
IDC_CHECKBOX18		equ		517					;
IDC_CHECKBOX19		equ		518					;
IDC_CHECKBOX20		equ		519					;
IDC_CHECKBOX21		equ		520					;
IDC_CHECKBOX22		equ		521					;
IDC_CHECKBOX23		equ		522					;
IDC_CHECKBOX24		equ		523					;
IDC_CHECKBOX25		equ		524					;
IDC_CHECKBOXPause	equ		525

;*		Port A labels
IDC_SPORTA0			equ		600					; Port A bit 0
IDC_SPORTA1			equ		601					; Port A bit 1
IDC_SPORTA2			equ		602					; Port A bit 2
IDC_SPORTA3			equ		603					; Port A bit 3
IDC_SPORTA4			equ		604					; Port A bit 4
IDC_SPORTA5			equ		605					; Port A bit 5
IDC_SPORTA6			equ		606					; Port A bit 6
IDC_SPORTA7			equ		607					; Port A bit 7

IDC_STRISA0			equ		608					; Tris A bit 0
IDC_STRISA1			equ		609					; Tris A bit 1
IDC_STRISA2			equ		610					; Tris A bit 2
IDC_STRISA3			equ		611					; Tris A bit 3
IDC_STRISA4			equ		612					; Tris A bit 4
IDC_STRISA5			equ		613					; Tris A bit 5
IDC_STRISA6			equ		614					; Tris A bit 6
IDC_STRISA7			equ		615					; Tris A bit 7

;*		Port B labels
IDC_SPORTB0			equ		616					; Port B bit 0
IDC_SPORTB1			equ		617					; Port B bit 1
IDC_SPORTB2			equ		618					; Port B bit 2
IDC_SPORTB3			equ		619					; Port B bit 3
IDC_SPORTB4			equ		620					; Port B bit 4
IDC_SPORTB5			equ		621					; Port B bit 5
IDC_SPORTB6			equ		622					; Port B bit 6
IDC_SPORTB7			equ		623					; Port B bit 7

IDC_STRISB0			equ		624					; Tris B bit 0
IDC_STRISB1			equ		625					; Tris B bit 1
IDC_STRISB2			equ		626					; Tris B bit 2
IDC_STRISB3			equ		627					; Tris B bit 3
IDC_STRISB4			equ		628					; Tris B bit 4
IDC_STRISB5			equ		629					; Tris B bit 5
IDC_STRISB6			equ		630					; Tris B bit 6
IDC_STRISB7			equ		631					; Tris B bit 7

;*		Port C labels
IDC_SPORTC0			equ		632					; Port C bit 0
IDC_SPORTC1			equ		633					; Port C bit 1
IDC_SPORTC2			equ		634					; Port C bit 2
IDC_SPORTC3			equ		635					; Port C bit 3
IDC_SPORTC4			equ		636					; Port C bit 4
IDC_SPORTC5			equ		637					; Port C bit 5
IDC_SPORTC6			equ		638					; Port C bit 6
IDC_SPORTC7			equ		639					; Port C bit 7

IDC_STRISC0			equ		640					; Tris C bit 0
IDC_STRISC1			equ		641					; Tris C bit 1
IDC_STRISC2			equ		642					; Tris C bit 2
IDC_STRISC3			equ		643					; Tris C bit 3
IDC_STRISC4			equ		644					; Tris C bit 4
IDC_STRISC5			equ		645					; Tris C bit 5
IDC_STRISC6			equ		646					; Tris C bit 6
IDC_STRISC7			equ		647					; Tris C bit 7

;*		Port D labels
IDC_SPORTD0			equ		648					; Port D bit 0
IDC_SPORTD1			equ		649					; Port D bit 1
IDC_SPORTD2			equ		650					; Port D bit 2
IDC_SPORTD3			equ		651					; Port D bit 3
IDC_SPORTD4			equ		652					; Port D bit 4
IDC_SPORTD5			equ		653					; Port D bit 5
IDC_SPORTD6			equ		654					; Port D bit 6
IDC_SPORTD7			equ		655					; Port D bit 7

IDC_STRISD0			equ		656					; Tris D bit 0
IDC_STRISD1			equ		657					; Tris D bit 1
IDC_STRISD2			equ		658					; Tris D bit 2
IDC_STRISD3			equ		659					; Tris D bit 3
IDC_STRISD4			equ		660					; Tris D bit 4
IDC_STRISD5			equ		661					; Tris D bit 5
IDC_STRISD6			equ		662					; Tris D bit 6
IDC_STRISD7			equ		663					; Tris D bit 7

;*		LED Label
IDC_STATICLED3		EQU		664
IDC_STATICLED2		EQU		665
IDC_STATICLED1		EQU		666
IDC_STATICLED0		EQU		667

;*		Count labels
IDC_STATICGCount	EQU		668					; game count
IDC_STATICSCount	EQU		669					; set count
IDC_STATICECount	EQU		670					; energy level

;*		Buttons
IDC_BUTTONAccept	EQU		700					; accept changes button
IDC_BUTTONNSet		EQU		701					; next set button
IDC_BUTTONNGame		EQU		702					; next game button

					;*====	Offset to port and bit data in string	====
					
					.DATA?
hInstance			DWORD ?

					;*====	Instruction arrays	====
					;*====	0 = TRIS			====
					;*====	1 = TRISbits		====
					;*====	2 = PORT			====
					;*====	3 = PORTbits		====
InstrList			db		MAX_INSTRUCTIONS dup (?)	; instruction type list for 256 lines
IPortList			db		MAX_INSTRUCTIONS dup (?)	; port name type list for 256 lines
IBitList			db		MAX_INSTRUCTIONS dup (?)	; bit number type list for 256 lines
IDataList			db		MAX_INSTRUCTIONS dup (?)	; data for instruction list for 256 lines
IDTypList			db		MAX_INSTRUCTIONS dup (?)	; data type for instruction list for 256 lines
ErrLineList			db		MAX_INSTRUCTIONS dup (?)	; error line list for 256 lines
ErrDataList			db		MAX_INSTRUCTIONS dup (?)	; error data list for 256 lines
StrList				db		MAX_INSTRUCTIONS*24 dup (?)	; string list array

RunLine				db		?					; run line number in instruction array
CurLine				db		?					; current line number in current set
CurSet				db		?					; current set number
CurGame				db		?					; current game number
CurErr				db		?					; number of errors so far
CurState			db		1 dup (?)			; current running state, 0 = start, 1 = Running, 2 = completed
CurEnergy			db		?					; current energy level

Seed				dd		?					; seed data

					;*====	Checkbox Control handle	====
hCHECKBOX1			dd		1 dup (?)			; instruction 1 checkbox handle
hCHECKBOX2			dd		1 dup (?)			; instruction 2 checkbox handle
hCHECKBOX3			dd		1 dup (?)			; instruction 3 checkbox handle
hCHECKBOX4			dd		1 dup (?)			; instruction 4 checkbox handle
hCHECKBOX5			dd		1 dup (?)			; instruction 5 checkbox handle
hCHECKBOX6			dd		1 dup (?)			; instruction 6 checkbox handle
hCHECKBOX7			dd		1 dup (?)			; instruction 7 checkbox handle
hCHECKBOX8			dd		1 dup (?)			; instruction 8 checkbox handle
hCHECKBOX9			dd		1 dup (?)			; instruction 9 checkbox handle
hCHECKBOX10			dd		1 dup (?)			; instruction 10 checkbox handle
hCHECKBOX11			dd		1 dup (?)			; instruction 11 checkbox handle
hCHECKBOX12			dd		1 dup (?)			; instruction 12 checkbox handle
hCHECKBOX13			dd		1 dup (?)			; instruction 13 checkbox handle
hCHECKBOX14			dd		1 dup (?)			; instruction 14 checkbox handle
hCHECKBOX15			dd		1 dup (?)			; instruction 15 checkbox handle
hCHECKBOX16			dd		1 dup (?)			; instruction 16 checkbox handle
hCHECKBOX17			dd		1 dup (?)			; instruction 17 checkbox handle
hCHECKBOX18			dd		1 dup (?)			; instruction 18 checkbox handle
hCHECKBOX19			dd		1 dup (?)			; instruction 19 checkbox handle
hCHECKBOX20			dd		1 dup (?)			; instruction 20 checkbox handle
hCHECKBOX21			dd		1 dup (?)			; instruction 21 checkbox handle
hCHECKBOX22			dd		1 dup (?)			; instruction 22 checkbox handle
hCHECKBOX23			dd		1 dup (?)			; instruction 23 checkbox handle
hCHECKBOX24			dd		1 dup (?)			; instruction 24 checkbox handle
hCHECKBOX25			dd		1 dup (?)			; instruction 25 checkbox handle
hCHECKBOXPause		dd		1 dup (?)			; instruction pause checkbox handle

					;*====	Port A control handle	====
hSPORTA0			dd		1 dup (?)			; port A bit 0 label control handle
hSPORTA1			dd		1 dup (?)			; port A bit 1 label control handle
hSPORTA2			dd		1 dup (?)			; port A bit 2 label control handle
hSPORTA3			dd		1 dup (?)			; port A bit 3 label control handle
hSPORTA4			dd		1 dup (?)			; port A bit 4 label control handle
hSPORTA5			dd		1 dup (?)			; port A bit 5 label control handle
hSPORTA6			dd		1 dup (?)			; port A bit 6 label control handle
hSPORTA7			dd		1 dup (?)			; port A bit 7 label control handle

					;*====	TRIS A control handle	====
hSTRISA0			dd		1 dup (?)			; TRIS A bit 0 label control handle
hSTRISA1			dd		1 dup (?)			; TRIS A bit 1 label control handle
hSTRISA2			dd		1 dup (?)			; TRIS A bit 2 label control handle
hSTRISA3			dd		1 dup (?)			; TRIS A bit 3 label control handle
hSTRISA4			dd		1 dup (?)			; TRIS A bit 4 label control handle
hSTRISA5			dd		1 dup (?)			; TRIS A bit 5 label control handle
hSTRISA6			dd		1 dup (?)			; TRIS A bit 6 label control handle
hSTRISA7			dd		1 dup (?)			; TRIS A bit 7 label control handle

					;*====	Port B control handle	====
hSPORTB0			dd		1 dup (?)			; port B bit 0 label control hBndle
hSPORTB1			dd		1 dup (?)			; port B bit 1 label control hBndle
hSPORTB2			dd		1 dup (?)			; port B bit 2 label control hBndle
hSPORTB3			dd		1 dup (?)			; port B bit 3 label control hBndle
hSPORTB4			dd		1 dup (?)			; port B bit 4 label control hBndle
hSPORTB5			dd		1 dup (?)			; port B bit 5 label control hBndle
hSPORTB6			dd		1 dup (?)			; port B bit 6 label control hBndle
hSPORTB7			dd		1 dup (?)			; port B bit 7 label control hBndle

					;*====	TRIS B control handle	====
hSTRISB0			dd		1 dup (?)			; TRIS B bit 0 lBbel control hBndle
hSTRISB1			dd		1 dup (?)			; TRIS B bit 1 lBbel control hBndle
hSTRISB2			dd		1 dup (?)			; TRIS B bit 2 lBbel control hBndle
hSTRISB3			dd		1 dup (?)			; TRIS B bit 3 lBbel control hBndle
hSTRISB4			dd		1 dup (?)			; TRIS B bit 4 lBbel control hBndle
hSTRISB5			dd		1 dup (?)			; TRIS B bit 5 lBbel control hBndle
hSTRISB6			dd		1 dup (?)			; TRIS B bit 6 lBbel control hBndle
hSTRISB7			dd		1 dup (?)			; TRIS B bit 7 lBbel control hBndle

					;*====	PORT C control handle	====
hSPORTC0			dd		1 dup (?)			; port C bit 0 label control hCndle
hSPORTC1			dd		1 dup (?)			; port C bit 1 label control hCndle
hSPORTC2			dd		1 dup (?)			; port C bit 2 label control hCndle
hSPORTC3			dd		1 dup (?)			; port C bit 3 label control hCndle
hSPORTC4			dd		1 dup (?)			; port C bit 4 label control hCndle
hSPORTC5			dd		1 dup (?)			; port C bit 5 label control hCndle
hSPORTC6			dd		1 dup (?)			; port C bit 6 label control hCndle
hSPORTC7			dd		1 dup (?)			; port C bit 7 label control hCndle

					;*====	TRIS C control handle	====
hSTRISC0			dd		1 dup (?)			; TRIS C bit 0 lCbel control hCndle
hSTRISC1			dd		1 dup (?)			; TRIS C bit 1 lCbel control hCndle
hSTRISC2			dd		1 dup (?)			; TRIS C bit 2 lCbel control hCndle
hSTRISC3			dd		1 dup (?)			; TRIS C bit 3 lCbel control hCndle
hSTRISC4			dd		1 dup (?)			; TRIS C bit 4 lCbel control hCndle
hSTRISC5			dd		1 dup (?)			; TRIS C bit 5 lCbel control hCndle
hSTRISC6			dd		1 dup (?)			; TRIS C bit 6 lCbel control hCndle
hSTRISC7			dd		1 dup (?)			; TRIS C bit 7 lCbel control hCndle

					;*====	Port D control hDndle	====
hSPORTD0			dd		1 dup (?)			; port D bit 0 label control hDndle
hSPORTD1			dd		1 dup (?)			; port D bit 1 label control hDndle
hSPORTD2			dd		1 dup (?)			; port D bit 2 label control hDndle
hSPORTD3			dd		1 dup (?)			; port D bit 3 label control hDndle
hSPORTD4			dd		1 dup (?)			; port D bit 4 label control hDndle
hSPORTD5			dd		1 dup (?)			; port D bit 5 label control hDndle
hSPORTD6			dd		1 dup (?)			; port D bit 6 label control hDndle
hSPORTD7			dd		1 dup (?)			; port D bit 7 label control hDndle

					;*====	TRIS D control handle	====
hSTRISD0			dd		1 dup (?)			; TRIS D bit 0 lDbel control hDndle
hSTRISD1			dd		1 dup (?)			; TRIS D bit 1 lDbel control hDndle
hSTRISD2			dd		1 dup (?)			; TRIS D bit 2 lDbel control hDndle
hSTRISD3			dd		1 dup (?)			; TRIS D bit 3 lDbel control hDndle
hSTRISD4			dd		1 dup (?)			; TRIS D bit 4 lDbel control hDndle
hSTRISD5			dd		1 dup (?)			; TRIS D bit 5 lDbel control hDndle
hSTRISD6			dd		1 dup (?)			; TRIS D bit 6 lDbel control hDndle
hSTRISD7			dd		1 dup (?)			; TRIS D bit 7 lDbel control hDndle

					;*====	LED static label	====
hSLED3				dd		1 dup (?)			; static label for LED3
hSLED2				dd		1 dup (?)			; static label for LED2
hSLED1				dd		1 dup (?)			; static label for LED1
hSLED0				dd		1 dup (?)			; static label for LED0

					;*====	Counter control handle	====
hSGCount			dd		1 dup (?)			; static label for game count
hSSCount			dd		1 dup (?)			; static label for set count
hSECount			dd		1 dup (?)			; static label for energy count

					;*====	Button control handle	====
hbNGame				dd		1 dup (?)			; new game button control handle
hbNSet				dd		1 dup (?)			; new set button control handle
hbAccept			dd		1 dup (?)			; accept change button control handle

					;*====	Current state variables	====
CurInstr			db		1 dup (?)			; current instruction
CurPort				db		1 dup (?)			; current port name
CurBit				db		1 dup (?)			; current bit number
CurData				db		1 dup (?)			; current data
CurDTyp				db		1 dup (?)			; current data type
CurInpD				db		1 dup (?)			; current input data

InstrStr			db		32 dup (?)			; instruction string
ClickedLine			db		?					; clicked line number

					;*====	Click control number	====
					;*====	1 = Checkbox			====
					;*====	2 = PortA label			====
					;*====	3 = PortB label			====
					;*====	4 = PortC label			====
					;*====	5 = PortD label			====
					;*====	6 = TrisA label			====
					;*====	7 = TrisB label			====
					;*====	8 = TrisC label			====
					;*====	9 = TrisD label			====
ClickControl		db		?					; 

					;*====	Port bit data variable	====
PortA				db		?					; port A data state
PortB				db		?					; port B data state
PortC				db		?					; port C data state
PortD				db		?					; port D data state
TrisA				db		?					; tris A data state
TrisB				db		?					; tris B data state
TrisC				db		?					; tris C data state
TrisD				db		?					; tris D data state
					
CurLblBit			db		?					; current label clicked bit number
CurCtrlID			dd		?					; current clicked control ID
CurCtrlHndle		dd		?					; current clicked control handle

					.DATA

szTris				DB	"TRIS",0				; TRIS instruction
szBits				DB 	"bits.",0				; bits
szPort				DB 	"PORT",0				; 
szIn				db		'In',0				; input message
szOut				db		'Out',0				; output message
szHigh				db		'1',0				; high state message
szLow				db		'0',0				; low state message
szuChip				db		'Microchip 18Fxxx C-Language Simulator Program',0

